/*
*******************************************************************************
**
**  This device driver was created by Applilet2 for 78K0/Kx2
**  8-Bit Single-Chip Microcontrollers
**
**  Copyright(C) NEC Electronics Corporation 2002 - 2011
**  All rights reserved by NEC Electronics Corporation.
**
**  This program should be used on your own responsibility.
**  NEC Electronics Corporation assumes no responsibility for any losses
**  incurred by customers or third parties arising from the use of this file.
**
**  Filename :	 main.c
**  Abstract :	This file implements main function.
**  APIlib :	Applilet2 for 78K0/Kx2 V2.41 [29 Apr. 2008]
**
**  Device :	uPD78F0515_48
**
**  Compiler :	CC78K0
**
**  Creation date:	2011/09/02
**  
*******************************************************************************
*/

/*
*******************************************************************************
**  Include files
*******************************************************************************
*/
#include "macrodriver.h"
#include "Port.h"
#include "System.h"
/* Start user code for include definition. Do not edit comment generated here */
/* End user code for include definition. Do not edit comment generated here */
#include "user_define.h"

/*
*******************************************************************************
**  Global define
*******************************************************************************
*/
/* Start user code for global definition. Do not edit comment generated here */
/* End user code for global definition. Do not edit comment generated here */


/*
**-----------------------------------------------------------------------------
**
**	Abstract:
**		This function  implements main function.
**
**	Parameters:
**		None
**
**	Returns:
**		None
**
**-----------------------------------------------------------------------------
*/
#define	LCD_CMD_WAIT		400
#define	LCD_BIT_WAIT		30
#define	PRESET_MAX			14
#define	FREQ_MIN			12850
#define	FREQ_MAX			13270

unsigned int	khz_no;
unsigned int	khz_no_m;
unsigned int	out_volt_data;
unsigned int	test_tun_data;
unsigned int	adj;

unsigned int	freq_khz;
unsigned int	freq_khz_b;
unsigned int	freq_khz_sub;

unsigned int	khz_no_setmode;


unsigned char	d_flg;
unsigned char	tun_level;

unsigned int	k_set[PRESET_MAX];
/*
unsigned int	t_set[PRESET_MAX];
*/
unsigned char	preset_no;
unsigned int	preset[PRESET_MAX];
unsigned char	preset_no_setmode;

unsigned char	set_count;
unsigned char	tun_flg;



void	wait_time(unsigned int time)
{
	while(time!=0){
		time--;
	}
}
void	nop(void)
{
unsigned int	x;

	x=0xffff;
	
}
/*----------  LCD MODULE ----------*/
void	lcd_db(unsigned char data)
{
	P3.0=data&0x01;
	P3.1=(data&0x02)>>1;
	P3.2=(data&0x04)>>2;
	P3.3=(data&0x08)>>3;
}
void	lcd_wait(void)
{
	wait_time(5000);
}
void	lcd_c_set(void)
{
	P13.0=0;
	P14.0=1;
	wait_time(LCD_BIT_WAIT);
	P14.0=0;
}
void	lcd_d_set(void)
{
	P13.0=1;
	P14.0=1;
	wait_time(LCD_BIT_WAIT);
	P14.0=0;
}
void	lcd_cmd(unsigned char data)
{
	lcd_db((data&0xf0)>>4);
	lcd_c_set();
	lcd_db(data&0x0f);
	lcd_c_set();
	wait_time(LCD_CMD_WAIT);
}
void	lcd_data(unsigned char data)
{
	lcd_db((data&0xf0)>>4);
	lcd_d_set();
	lcd_db(data&0x0f);
	lcd_d_set();
	wait_time(LCD_CMD_WAIT);
}
void	lcd_init(void)
{
	lcd_wait();
	lcd_db(3);
	lcd_c_set();
	lcd_wait();
	lcd_db(3);
	lcd_c_set();
	lcd_wait();
	lcd_db(3);
	lcd_c_set();
	lcd_wait();
	lcd_db(2);
	lcd_c_set();
	lcd_wait();
	
	lcd_cmd(0x28);
	lcd_cmd(0x08);
	lcd_cmd(0x0c);
	lcd_cmd(0x06);
}
void	lcd_clear(void)
{
	lcd_cmd(0x01);
}
void	lcd_xy(unsigned char x,unsigned char y)
{
unsigned char data;

	data=0x80;
	switch (y){
		case 0:data=0x80;break;
		case 1:data=0xc0;break;
		case 2:data=0x90;break;
		case 3:data=0xd0;break;
	}
	data=data+x;
	lcd_cmd(data);
}
void	lcd_print(char *data)
{
	while (*data!=0){
		lcd_data(*data++);
	}
}
void	lcd_su(unsigned char data)
{
	switch (data){
		case 0:lcd_print("0");break;
		case 1:lcd_print("1");break;
		case 2:lcd_print("2");break;
		case 3:lcd_print("3");break;
		case 4:lcd_print("4");break;
		case 5:lcd_print("5");break;
		case 6:lcd_print("6");break;
		case 7:lcd_print("7");break;
		case 8:lcd_print("8");break;
		case 9:lcd_print("9");break;
		case 10:lcd_print("A");break;
		case 11:lcd_print("B");break;
		case 12:lcd_print("C");break;
		case 13:lcd_print("D");break;
		case 14:lcd_print("E");break;
		case 15:lcd_print("F");break;
	}
}
void	lcd_khz(unsigned int hz)
{
unsigned char n0,n1,n2,n3,n4;
unsigned int count;

	count=hz;
	n0=(unsigned char)(count%10);count=(count-n0)/10;
	n1=(unsigned char)(count%10);count=(count-n1)/10;
	n2=(unsigned char)(count%10);count=(count-n2)/10;
	n3=(unsigned char)(count%10);count=(count-n3)/10;
	n4=(unsigned char)(count%10);

	if(n4==0){lcd_print(" ");}else{lcd_su(n4);}
	if((n4==0)&(n3==0)){lcd_print(" ");}else{lcd_su(n3);}
	lcd_su(n2);
	lcd_su(n1);
	lcd_su(n0);
}
void	lcd_pr_byte(unsigned char data)
{
unsigned char data2;

	data2=data%16;data=data/16;
	lcd_su(data);
	lcd_su(data2);
}
void	lcd_ini_disp(void)
{
	lcd_xy(3,0);
	lcd_print("     0kHz");
}
void	lcd_1keta10(unsigned char count)
{
unsigned char n0;

	n0=(unsigned char)(count%10);

	lcd_su(n0);
}

void	lcd_2keta10(unsigned char count)
{
unsigned char n0,n1;

	n0=(unsigned char)(count%10);count=(count-n0)/10;
	n1=(unsigned char)(count%10);

	lcd_su(n1);
	lcd_su(n0);
}
void	lcd_4keta10(unsigned int count)
{
unsigned char n0,n1,n2,n3;

	n0=(unsigned char)(count%10);count=(count-n0)/10;
	n1=(unsigned char)(count%10);count=(count-n1)/10;
	n2=(unsigned char)(count%10);count=(count-n2)/10;
	n3=(unsigned char)(count%10);

	lcd_su(n3);
	lcd_su(n2);
	lcd_su(n1);
	lcd_su(n0);
}

/*---------- VOLTAGE  ----------*/
void	dac_out_ch1(unsigned int data)
{
unsigned int 	d0;
unsigned char	d1;
unsigned char	i;

	P7.3=0;
	P7.4=1;
	d0=data << 4;
	d1=0x20;
	P7.4=0;
	
	for(i=0;i<8;i++){
		if((d1 & 0x80)==0x80){
			P7.5=1;
		}
		else{
			P7.5=0;
		}
		P7.3=1;
		d1=d1 << 1;
		P7.3=0;
	}
	
	for(i=0;i<16;i++){
		if((d0 & 0x8000)==0x8000){
			P7.5=1;
		}
		else{
			P7.5=0;
		}
		P7.3=1;
		d0=d0 << 1;
		P7.3=0;
	}
	P7.4=1;
	P7.5=0;
}
void	dac_out_ch2(unsigned int data)
{
unsigned int 	d0;
unsigned char	d1;
unsigned char	i;

	P7.3=0;
	P7.4=1;
	d0=data << 4;
	d1=0x21;
	P7.4=0;
	
	for(i=0;i<8;i++){
		if((d1 & 0x80)==0x80){
			P7.5=1;
		}
		else{
			P7.5=0;
		}
		P7.3=1;
		d1=d1 << 1;
		P7.3=0;
	}
	
	for(i=0;i<16;i++){
		if((d0 & 0x8000)==0x8000){
			P7.5=1;
		}
		else{
			P7.5=0;
		}
		P7.3=1;
		d0=d0 << 1;
		P7.3=0;
	}
	P7.4=1;
	P7.5=0;
}


void	vol_out1(unsigned int volt)
{
	dac_out_ch1(volt);		/* DAC1 CH A */
}
void	volt_up1(void)
{
	out_volt_data++;
	if(out_volt_data>=4096){
		out_volt_data=4095;
	}
}
void	volt_down1(void)
{
	if(out_volt_data>0){
		out_volt_data--;
	}
}
void	vol_out_tun1(unsigned int volt)
{
	dac_out_ch2(volt);		/* DAC1 CH B */
}

void	vol_out_sub(unsigned int volt)
{
	vol_out1(volt);
}
void	vol_out_tun_sub(unsigned int volt)
{
	vol_out_tun1(volt);
}

/*----------  KHZ    ----------*/
void	khz_set(unsigned char n)
{
	out_volt_data=k_set[n];
	vol_out_sub(out_volt_data);
	/*lcd_xy(12,1);lcd_4keta10(out_volt_data);*/
}

void	khz_set_tun(unsigned char n)
{
	/*
	test_tun_data=k_set[n];
	vol_out_tun_sub(test_tun_data);
	*/

	/*
	test_tun_data=t_set[n];
	vol_out_tun_sub(test_tun_data);
	*/

}

/*----------- DATA INPUT ----------*/
void	freq_count_in(void)
{
unsigned long freq1;
unsigned int d0,d1,d2,d3,d4,d5;
unsigned char port2;

	P7.2=1;
	nop();				/* wait */
	P7.2=0;
	P7.0=1;P7.1=0;
	nop();				/* wait */
	port2=P2;
	d4=(port2 & 0xf0) >> 4;
	d5=(port2 & 0x0f);
	
	P7.0=0;P7.1=1;
	nop();				/* wait */
	port2=P2;
	d2=(port2 & 0xf0) >> 4;
	d3=(port2 & 0x0f);

	P7.0=1;P7.1=1;
	nop();				/* wait */
	port2=P2;
	d0=(port2 & 0xf0) >> 4;
	d1=(port2 & 0x0f);

	freq1=(unsigned long)d0+(unsigned long)d1*10+(unsigned long)d2*100+(unsigned long)d3*1000+(unsigned long)d4*10000+(unsigned long)d5*100000;

	freq_khz_sub=(unsigned int)(freq1%10);
	freq_khz=(unsigned int)((freq1-freq_khz_sub)/10);
	
	P7.2=0;

}
/*---------- PRESET ---------*/
unsigned char	preset_next(unsigned char no)
{
unsigned char i,ret;

	ret=no;
	no++;
	if(no>=PRESET_MAX){no=0;}
	for(i=no;i<PRESET_MAX;i++){
		if(preset[i]!=0){
			ret=i;
			return ret;
		}
	}
	for(i=0;i<no;i++){
		if(preset[i]!=0){
			ret=i;
			return ret;
		}
	}
	return ret;
}

/*---------- INIT ---------*/

void	data_init(void)
{

		preset[0]=12850;
		preset[1]=12915;
		preset[2]=13025;
		preset[3]=13095;
		preset[4]=13105;
		preset[5]=13117;
		preset[6]=13125;
		preset[7]=13145;
		preset[8]=13195;
		preset[9]=13230;
		preset[10]=13240;
		preset[11]=13245;
		preset[12]=13250;
		preset[13]=13270;

		k_set[0]=1098;
		k_set[1]=1475;
		k_set[2]=2169;
		k_set[3]=2637;
		k_set[4]=2705;
		k_set[5]=2787;
		k_set[6]=2841;
		k_set[7]=2981;
		k_set[8]=3328;
		k_set[9]=3577;
		k_set[10]=3649;
		k_set[11]=3683;
		k_set[12]=3719;
		k_set[13]=3862;

		/*
		t_set[0]=0;
		t_set[1]=200;
		t_set[2]=560;
		t_set[3]=820;
		t_set[4]=850;
		t_set[5]=900;
		t_set[6]=928;
		t_set[7]=999;
		t_set[8]=1158;
		t_set[9]=1280;
		t_set[10]=1320;
		t_set[11]=1340;
		t_set[12]=1360;
		t_set[13]=1410;
		*/
		
		khz_no=FREQ_MIN;
}


/*---------- MAIN -----------*/
void	main( void )
{
unsigned int	sub;
unsigned char	sw1_key;
unsigned char	sw1_rep;
unsigned char	sw1_cnt;


	out_volt_data=0;

	sw1_key=0;sw1_rep=0;sw1_cnt=0;
	preset_no=0;


	lcd_init();
	lcd_clear();

	lcd_xy(0,1);
	lcd_print("AIRBAND RECEIVER");
	wait_time(50000);

	data_init();

	lcd_xy(0,1);
	lcd_print("         kHz    ");

	lcd_ini_disp();
	
	P7.4=1;
	
	
	freq_khz_b=0;
	adj=0;sub=0;
	d_flg=0;tun_level=0;
	tun_flg=0;

	
	khz_no=preset[preset_no];
	khz_set(preset_no);
	khz_set_tun(preset_no);
	lcd_xy(3,0);
	lcd_khz(khz_no);
	adj=0;d_flg=0;

	/* Start user code. Do not edit comment generated here */
	while (1) {
	/* key scan 1 */
		if (P1.0==0){
				sw1_key=0;
		}
		else{
			sw1_key=1;
			sw1_rep=0;
			sw1_cnt=0;
		}
		/*------------------*/


		if(freq_khz!=freq_khz_b){
			freq_khz_b=freq_khz;
		}
		
		/*wait_time(2000);*/
		wait_time(1000);
		


		if(freq_khz>(khz_no+3)){adj=0;}
		if(freq_khz<(khz_no-3)){adj=0;}

		if(adj==0){
		/*--------------------*/
		freq_count_in();
		

		if(freq_khz==khz_no){
			switch(freq_khz_sub){
				case 9:
				case 8:
				case 7:
				case 6:
				case 5:
				case 4:
				case 3:
						volt_down1();
						vol_out_sub(out_volt_data);
						khz_set_tun(preset_no);
						adj=0;d_flg=1;tun_level=0;
						break;
				case 2:	tun_level=1;adj=150;d_flg=1;k_set[preset_no]=out_volt_data;
						/*vol_out_sub(out_volt_data);
						khz_set_tun();*/
						break;
				case 1:	tun_level=2;adj=150;d_flg=1;k_set[preset_no]=out_volt_data;
						/*vol_out_sub(out_volt_data);
						khz_set_tun();*/
						break;
				case 0:	tun_level=3;adj=150;d_flg=1;k_set[preset_no]=out_volt_data;
						/*vol_out_sub(out_volt_data);
						khz_set_tun();*/
						break;
			}
		}
		if(freq_khz==(khz_no+1)){
						volt_down1();
						vol_out_sub(out_volt_data);
						khz_set_tun(preset_no);
						adj=0;d_flg=0;tun_level=0;
		}
		if(freq_khz==(khz_no-1)){
			switch(freq_khz_sub){
				case 9:	tun_level=2;adj=150;d_flg=1;k_set[preset_no]=out_volt_data;
						/*vol_out_sub(out_volt_data);
						khz_set_tun();*/
						break;
				case 8:	tun_level=1;adj=150;d_flg=1;k_set[preset_no]=out_volt_data;
						/*vol_out_sub(out_volt_data);
						khz_set_tun();*/
						break;
				case 7:
				case 6:
				case 5:
				case 4:
				case 3:
				case 2:
				case 1:
				case 0:
						volt_up1();
						vol_out_sub(out_volt_data);
						khz_set_tun(preset_no);
						adj=0;d_flg=1;tun_level=0;
						break;
			}
		}
		if(freq_khz>(khz_no+1)){
						volt_down1();
						vol_out_sub(out_volt_data);
						khz_set_tun(preset_no);
						adj=0;d_flg=0;tun_level=0;
		}
		if(freq_khz<(khz_no-1)){
						volt_up1();
						vol_out_sub(out_volt_data);
						khz_set_tun(preset_no);
						adj=0;d_flg=0;tun_level=0;
		}
		
		if(d_flg==1){
		
			/*--------------
			lcd_xy(3,1);
			lcd_khz(freq_khz);
			lcd_xy(8,1);
			lcd_1keta10((unsigned char)freq_khz_sub);
			lcd_xy(12,0);lcd_4keta10(out_volt_data);
			--------------*/
			
				lcd_xy(0,0);
				switch(tun_level){
					case 0:lcd_print("   ");break;
					case 1:lcd_print("*  ");break;
					case 2:lcd_print("** ");break;
					case 3:lcd_print("***");break;
				}
				lcd_xy(12,0);lcd_4keta10(out_volt_data);
		}

			/*-------------------------------*/
			lcd_xy(3,1);
			lcd_khz(freq_khz);
			lcd_xy(8,1);
			lcd_1keta10((unsigned char)freq_khz_sub);
			lcd_xy(12,0);lcd_4keta10(out_volt_data);
			/*-----------------------------*/
		

		/*-----------------------*/
		}
		else{
			adj--;
		}
		/*-------------------*/

	/* key scan 2 */
		if ((P1.0==0)&&(sw1_key==0)){
			sw1_key=0;
		}
		else{
			sw1_key=1;
			sw1_rep=0;
			sw1_cnt=0;
		}
		/*------------------*/


	/* key action */
	
		if((sw1_key==0)&&(sw1_rep==0)){
						sw1_rep=1;
						lcd_xy(0,0);lcd_print("   ");
						preset_no=preset_next(preset_no);
						khz_no=preset[preset_no];
						khz_set(preset_no);
						khz_set_tun(preset_no);
						lcd_xy(3,0);
						lcd_khz(khz_no);
						adj=0;d_flg=0;
						sw1_cnt=0;
						
						lcd_xy(0,1);
						lcd_print("         kHz    ");
						lcd_xy(12,0);
						lcd_print("    ");
						
		}
		/*------------------*/

	}
	/* End user code. Do not edit comment generated here */
}

/* Start adding user code. Do not edit comment generated here */
/* End user code adding. Do not edit comment generated here */


